package core.services.ntfy;

import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;

import java.net.URI;
import java.net.URISyntaxException;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;

public class NtfyTaskStartNotification implements Job {

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        HttpClient httpClient = HttpClient.newHttpClient();
        String msg = "Task " + jobExecutionContext.getMergedJobDataMap().getString("task") + " should have been started by now!";

        try {
            HttpRequest request = HttpRequest.newBuilder()
                    .uri(new URI("http://localhost:4280/Test"))
                    .POST(HttpRequest.BodyPublishers.ofString(msg))
                    .header("Tags", "warning")
                    .header("Title", "Task Starting Reminder")
                    .header("Actions", "view, Open TimeScheduler, https://time.fawkes100.de/, clear=true")
                    .build();

            httpClient.sendAsync(request, HttpResponse.BodyHandlers.ofString());
        } catch (URISyntaxException e) {
            throw new RuntimeException(e);
        }
    }
}
